using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using SharpCharts.Base.Data;
using System.Xml.Serialization;
using System.Windows.Media;
using SharpCharts.Base.ChartObject;
using System.Windows.Input;
using SharpCharts.Base.Common;

namespace SharpCharts.Base.SharpScript
{
    public class Straddle : Indicator
    {
    
    	    	
        public Straddle() : base()
        {   
            base.PanelCount = 0;
            base.Calculate = Base.SharpScript.Calculate.OnPriceChange;
            this.InstrumentCommand = new RelayCommand<Instrument>(OnInstrument);
            this.Instrument1 = string.Format(System.Globalization.CultureInfo.InvariantCulture, "NIFTY {0:MM yyyy} 16000 Put NSE", DateTime.Now);
        }


        protected override void OnStateChange()
        {
            
            switch (base.State)
            {
                case State.Finalize:
                    break;
                case State.Initialize:
                	
                    AddPlot(new Plot("Close", new LinePlotStyle(), Brushes.Green, 2));

					AddBars(this.Secondary.DisplayName);
                    break;
                case State.StartUp:
                		
                    break;
                default:
                    break;
            }
        }
        
        

        protected override void OnBarUpdate()
        {
         	if (CurrentBars[0] < 0 || CurrentBars[1] < 0)
         		return;
         		
         	Values[0][0] = Closes[0][0] + Closes[1][0];
         	
        }
        
                
        private void OnInstrument(Instrument instrument)
        {
        
        	this.Secondary = instrument;
        	
        	if (this.Secondary != null)
        	{
        		if (this.State == State.Initialize)
        		{
        			if (BarsArray.Length < 2)
        			{
        				AddBars(this.Secondary.DisplayName);
        			}
        			
        			SetSecondaryInstrument(Secondary.DisplayName, 1);
        		}
        	}
        }
        
                
        
		[XmlIgnore]
        public ICommand InstrumentCommand { get; private set; }
                
        private Instrument secondary = null;
        [XmlIgnore]
        public Instrument Secondary
        { 
        	get { return secondary; } 
        	set 
        	{
	        	secondary = value; 
	        	NotifyPropertyChanged("Secondary");	
	        }
        }
        
        private string instrument1;
		[Input]
        public string Instrument1
        {
        	get 
        	{
				if (this.Secondary == null)
					return instrument1;				
        		return this.Secondary.DisplayName; 
        	}
        	set
        	{
        		this.Secondary = null;
        		instrument1 = value;
        		if (!string.IsNullOrEmpty(instrument1))
        		{
        			if (this.State == State.Initialize)
        			{
        				SetSecondaryInstrument(instrument1, 1);
        			}
        		
        			Instrument.TryParse(instrument1, out this.secondary);
        		}
        		NotifyPropertyChanged("Instrument1");
        	}
        }


    }
}